//+------------------------------------------------------------------+
//|                                               Unsmoothed_RSI.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_minimum    0
#property indicator_maximum    100

#property indicator_buffers 1
#property indicator_color1 Yellow

#property indicator_level1 50
#property indicator_levelcolor Blue
#property indicator_levelwidth 1
#property indicator_levelstyle STYLE_DASH



extern int Length=14;
extern int Price=3;



      // Applied price
                         // 0 - Close
                         // 1 - Open
                         // 2 - High
                         // 3 - Low
                         // 4 - Median
                         // 5 - Typical
                         // 6 - Weighted 
 

double U_RSI[];
double Pos[], Neg[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   IndicatorDigits(Digits);
   SetIndexBuffer(0,U_RSI);
   SetIndexBuffer(1,Pos);
   SetIndexBuffer(2,Neg);
   IndicatorShortName("Unsmoothed RSI - custom SMA");
   return(0);
}
int deinit() { return(0); }
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for (int pos=limit; pos>=0; pos--)
   {
      double Diff=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos)-iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos+1);
      if (Diff>0)
            { Pos[pos]=Diff; Neg[pos]=0;     }
      else  { Pos[pos]=0;    Neg[pos]=-Diff; }
      double P=iSma(Pos[pos],Length,pos,0);
      double N=iSma(Neg[pos],Length,pos,1);
      if (N==0)
            U_RSI[pos]=0;
      else  U_RSI[pos]=100-(100/(1+P/N));
   }  
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][4];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

